/*
 * TkResolver++ - Psychokinesis testing software
 *
 * Copyright (C) 2009 Robert Ham <rah@bash.sh>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef __TK_EXP_DATABASE_OPERATION_H__
#define __TK_EXP_DATABASE_OPERATION_H__

#include <gtkmm.h>

#include "libtkdb/database.h"

namespace Tk {
  namespace Experimenter {

    class DatabaseOperation : public Gtk::Dialog
      {
      private:
	typedef std::map<const Tk::Db::Report *, Gtk::ProgressBar *> ReportProgressMap;
	ReportProgressMap _reports;
	
	Gtk::ProgressBar *find_progress(const Tk::Db::Report &report);
	void report(const Tk::Db::Report &report);
	void report_update(const Tk::Db::ReportUpdate &update);
	
      public:
	DatabaseOperation(Gtk::Window & parent, Tk::Db::Database *database);
      };
      
  } /* namespace Experimenter */
}; /* namespace Tk */




#endif /* __TK_EXP_DATABASE_OPERATION_H__ */
