/* -*- c++ -*-
 * TkResolver++ - Psychokinesis testing software
 *
 * Copyright (C) 2009 Robert Ham <rah@bash.sh>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef __TK_DB_BYTES_H__
#define __TK_DB_BYTES_H__

#include <list>

#include <odbc++/types.h>

#include "libtkcommon/stream.h"

namespace Tk {
  namespace Db {
    
    class Bytes : public odbc::Bytes
    {
    private:
      typedef std::list<Tk::Stream *> StreamList;
      StreamList _gotten_streams;
    public:
      Bytes();
      Bytes(const Bytes &other);
      Bytes(const ODBCXX_SIGNED_CHAR_TYPE *data, size_t len);

      Bytes(std::istream &stream, std::string::size_type *len = 0);
      virtual ~Bytes();
      Tk::Stream *get_stream();
    };
    
  }; /* namespace Db */
}; /* namespace Tk */


#endif /* __TK_DB_VALUE_H__ */
