/* -*- c++ -*-
 * TkResolver++ - Psychokinesis testing software
 *
 * Copyright (C) 2009 Robert Ham <rah@bash.sh>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include "libtkdbui/file_value.h"

using namespace Tk::Db::Ui;


FileValue:: FileValue(const Tk::Db::Bytes &bytes)
  : _bytes(bytes),
    Value(Tk::Db::Data::Blob)
{
  Gtk::Button *button = Gtk::manage( new Gtk::Button(Gtk::Stock::OPEN) );
  pack_start(*button, false, false);
  button->signal_clicked().connect( sigc::mem_fun(*this, &FileValue::load) );

  button = Gtk::manage( new Gtk::Button(Gtk::Stock::SAVE) );
  pack_start(*button, false, false);
  button->signal_clicked().connect( sigc::mem_fun(*this, &FileValue::save) );
}

void
FileValue:: load()
{
}

void
FileValue:: save()
{
}
